/*
 *  Fcalc - a touch-screen calculator for the GP2X-F200
 *  written (at a tube) by flynn@vtech.fr
 *  source GPL'ed    
 */     
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <dlfcn.h>

#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>


void *Mix_handle = NULL;

void libMix_open()
{
  if (Mix_handle == NULL)
  {
    void *handle = dlopen("libSDL_mixer.so", RTLD_LAZY);
    if (!handle) {
      fprintf(stderr, "%s\n", dlerror());
      exit(EXIT_FAILURE);
    }
  }
}

void libMix_close()
{
  if (Mix_handle != NULL) dlclose(Mix_handle) ;
  Mix_handle = NULL ;
}

#define Q(string) # string

#define VMIXDEF0(MIXname) \
void (*pMix_##MIXname)(void) = NULL ; \
void Mix_##MIXname(void) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pMix_##MIXname)(); \
}

#define VMIXDEF1(MIXname, MIXarg) \
void (*pMix_##MIXname)(MIXarg) = NULL ; \
void Mix_##MIXname(MIXarg arg1) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pMix_##MIXname)(arg1); \
}

#define MIXDEF0(MIXret, MIXname) \
MIXret (*pMix_##MIXname)(void) = NULL ; \
MIXret Mix_##MIXname(void) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pMix_##MIXname)(); \
}
#define MIXDEF1(MIXret, MIXname, MIXarg) \
MIXret (*pMix_##MIXname)(MIXarg) = NULL ; \
MIXret Mix_##MIXname(MIXarg arg1) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pMix_##MIXname)(arg1); \
}

#define MIXDEF2(MIXret, MIXname, MIXarg1, MIXarg2) \
MIXret (*pMix_##MIXname)(MIXarg1, MIXarg2) = NULL ; \
MIXret Mix_##MIXname(MIXarg1 arg1, MIXarg2 arg2) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pMix_##MIXname)(arg1, arg2); \
}

#define MIXDEF3(MIXret, MIXname, MIXarg1, MIXarg2, MIXarg3) \
MIXret (*pMix_##MIXname)(MIXarg1, MIXarg2, MIXarg3) = NULL ; \
MIXret Mix_##MIXname(MIXarg1 arg1, MIXarg2 arg2, MIXarg3 arg3) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pMix_##MIXname)(arg1, arg2, arg3); \
}

#define MIXDEF4(MIXret, MIXname, MIXarg1, MIXarg2, MIXarg3, MIXarg4) \
MIXret (*pMix_##MIXname)(MIXarg1, MIXarg2, MIXarg3, MIXarg4) = NULL ; \
MIXret Mix_##MIXname(MIXarg1 arg1, MIXarg2 arg2, MIXarg3 arg3, MIXarg4 arg4) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pMix_##MIXname)(arg1, arg2, arg3, arg4); \
}

#define VMIXDEF5(MIXname, MIXarg1, MIXarg2, MIXarg3, MIXarg4, MIXarg5) \
void (*pMix_##MIXname)(MIXarg1, MIXarg2, MIXarg3, MIXarg4, MIXarg5) = NULL ; \
void Mix_##MIXname(MIXarg1 arg1, MIXarg2 arg2, MIXarg3 arg3, MIXarg4 arg4, MIXarg5 arg5) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pMix_##MIXname)(arg1, arg2, arg3, arg4, arg5); \
}

#define MIXDEF8(MIXret, MIXname, MIXarg1, MIXarg2, MIXarg3, MIXarg4, \
	MIXarg5, MIXarg6, MIXarg7, MIXarg8) \
MIXret (*pMix_##MIXname)(MIXarg1, MIXarg2, MIXarg3, MIXarg4, \
	MIXarg5, MIXarg6, MIXarg7, MIXarg8) = NULL ; \
MIXret Mix_##MIXname(MIXarg1 arg1, MIXarg2 arg2, MIXarg3 arg3, MIXarg4 arg4, \
	MIXarg5 arg5, MIXarg6 arg6, MIXarg7 arg7, MIXarg8 arg8) \
{ \
  if (pMix_##MIXname == NULL) \
  { \
    char *error; \
    libMix_open() ; \
    dlerror(); \
    pMix_##MIXname = dlsym(Mix_handle, Q(Mix_##MIXname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pMix_##MIXname)(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8); \
}


VMIXDEF0(CloseAudio) ;
VMIXDEF1(FreeChunk, Mix_Chunk*) ;
MIXDEF1(int, Playing, int) ;
MIXDEF2(Mix_Chunk*, LoadWAV_RW, SDL_RWops*, int) ;
MIXDEF2(int, Volume, int, int) ;
MIXDEF4(int, OpenAudio, int, Uint16, int, int) ;
MIXDEF4(int, PlayChannelTimed, int, Mix_Chunk*, int, int) ;

