/*
 *  Fcalc - a touch-screen calculator for the GP2X-F200
 *  written (at a tube) by flynn@vtech.fr
 *  source GPL'ed    
 */     
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdint.h>
#include <sys/time.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_mixer.h>
#include "SDL_rotozoom.h"

#include "calc.h"

void libSDL_close(void) ;
void libTTF_close(void) ;
void libMix_close(void) ;

char quit = 0 ;
TTF_Font* font;
TTF_Font* fontSmall;
FILE *file;
unsigned char v400 = 0 ;

// FILE *sout ;

void handleMOUSEevent(int button, SDL_Surface* screen) ;

int translateXY(int x, int y)
{
  unsigned X1 = 2*(x-87)/57 ;
  unsigned Y1 = (y-8)/47 ;
  unsigned rX = (2*(x-87)-X1*57)/2 ;
  unsigned rY = (y-8)-Y1*47 ;
  // test case grande touche
  if ((y>=7) && (X1==7) && ((Y1==0) || ((Y1<=1) && (rY<=38)))) return 85 ; 
  if (rX>=23) return 0 ;
  if (rY>38) return 0 ;
  if (Y1>=5) return 0 ;
  if (X1>=8) return 0 ;
  return (X1+1)*10 + (5-Y1) ; 
}

inline unsigned long int time_msec ( void )
{
  struct timeval t;
  gettimeofday (&t, NULL);
  return (1000*t.tv_sec)+(t.tv_usec/1000);
}

inline unsigned long int time_100msec ( void )
{
  struct timeval t;
  gettimeofday (&t, NULL);
  return (10*t.tv_sec)+(t.tv_usec/100000);
}

void handleSDLEvent(SDL_Event* event, SDL_Surface* screen, Mix_Chunk *sound)
{
  int vol ;
 // fprintf(sout, "event %d\n", event->type) ;
 // printf("event %d\n", event->type) ;
    switch(event->type)
    {
    case SDL_QUIT:
        quit=1;
        break;

    // keys input
    case SDL_JOYBUTTONUP:
 // fprintf(sout, "buttonup %d %d\n", event->jbutton.button, event->jbutton.state) ;
	break ;
    case SDL_JOYBUTTONDOWN:
        {
 // fprintf(sout, "buttondown %d %d\n", event->jbutton.button, event->jbutton.state) ;
            switch(event->jbutton.button)
            {
            case 8:
                quit=1;
                break;
	    case 16 :
		vol = Mix_Volume(0, -1) ;
		vol+=16 ;
		if (vol>128) vol=128 ;
		Mix_Volume(-1, vol) ;
	        Mix_PlayChannel(-1, sound, 0);
		break ;
	    case 17 :
		vol = Mix_Volume(0, -1) ;
		vol-=16 ;
		if (vol<0) vol=0 ;
		Mix_Volume(-1, vol) ;
	        Mix_PlayChannel(-1, sound, 0);
		break ;
            }
        }
        break;

    case SDL_KEYDOWN:
	quit=1 ;
	break ;
    case SDL_MOUSEBUTTONDOWN:
	{
	//   fprintf(sout, "mouse %d %d\n", event->button.x, event->button.y) ;
	//   printf("mouse %d %d\n", event->button.x, event->button.y) ;
#if 0
  	  int button = translateXY(event->button.x, event->button.y) ;
  	  if (button!=0) 
	  {
	    Mix_PlayChannel(-1, sound, 0);
	    handleMOUSEevent(button, screen) ;
	  }
#endif
	}
	break ;
    }
}


void drawText(SDL_Surface* screen, char* string, int x, int y, int fR, int fG, int fB, int f)
{
  SDL_Surface *textSurface ;
  SDL_Color foregroundColor = { fR, fG, fB };
  if (f==0)
    textSurface =  TTF_RenderText_Blended(font,string, foregroundColor); else
    textSurface =  TTF_RenderText_Blended(fontSmall,string, foregroundColor);
  SDL_Rect textLocation = { x, y, 0, 0 };
  // fprintf(sout, "rotozoomSurface\n") ;
  SDL_Surface *rotation = rotozoomSurface(textSurface, 90.0, 1.0, 0);
  SDL_BlitSurface(rotation, NULL, screen, &textLocation);
//  SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
  SDL_FreeSurface(rotation);
  SDL_FreeSurface(textSurface);
}

typedef struct {
    uint16_t               pressure;
    uint16_t              x;
    uint16_t               y;
    uint16_t               pad;
    struct timeval  stamp;
} TS_EVENT;


void display_bmp(char *file_name, SDL_Surface *screen)
{
    SDL_Surface *image;

    /* Load the BMP file into a surface */
    image = SDL_LoadBMP(file_name);
    if (image == NULL) {
        fprintf(stderr, "Couldn't load %s: %s\n", file_name, SDL_GetError());
        return;
    }

    /*
 *      * Palettized screen modes will have a default palette (a standard
 *      * 8*8*4 colour cube), but if the image is palettized as well we can
 *      * use that palette for a nicer colour matching
 *   */
    if (image->format->palette && screen->format->palette) {
    SDL_SetColors(screen, image->format->palette->colors, 0,
                  image->format->palette->ncolors);
    }

    /* Blit onto the screen surface */
    if(SDL_BlitSurface(image, NULL, screen, NULL) < 0)
        fprintf(stderr, "BlitSurface error: %s\n", SDL_GetError());

    SDL_UpdateRect(screen, 0, 0, image->w, image->h);

    // these 3 lines to recover broken images that gimp screwed up.
    
    // char fn[64] ;
    // strcpy(fn, "/tmp/") ; strcat(fn, file_name) ;
    // SDL_SaveBMP(image, fn) ;
    //
    /* Free the allocated BMP surface */
    SDL_FreeSurface(image);
}

void  display_page(SDL_Surface* screen)
{
  if (ctx.page==0)
    display_bmp("fcalc/fcalc.bmp", screen) ; else
    display_bmp("fcalc/fcalc9.bmp", screen) ;
}

void display_all(SDL_Surface *screen)
{
  display_page(screen) ;
  // calc_print() ;
  if (ctx.s_ndx>0)
  {
    char buf[4] ;
    sprintf(buf, "(%d", ctx.s_ndx) ;
    drawText(screen,buf,10,10,0,0,0,1); 
  }

  if (ctx.deg!=0)
    drawText(screen,"Deg",10,130,0,0,0,1); else
    drawText(screen,"Rad",10,130,0,0,0,1); 
  if (ctx.fix==-2)
    drawText(screen,"Norm",10,80,0,0,0,1); else
  if (ctx.fix==-1)
    drawText(screen,"Sci",10,80,0,0,0,1); else
  {
    char buf[16] ;
    sprintf(buf, "fix%d", ctx.fix) ;
    drawText(screen,buf,10,80,0,0,0,1); 
  }
  if (ctx.mem != 0.0)
    drawText(screen,"M",10,50,0,0,0,1); else
    drawText(screen," ",10,50,0,0,0,1); 

  // drawText(screen,ctx.exp, 10, 100, 0, 0, 0, 1) ;
  {
    char buf[32] ;
    char *p=ctx.mant ;
    while(*p==' ') p++ ;
    if (!strcmp(ctx.exp, "   "))
      sprintf(buf, "%c%s", ctx.sign, p) ; else
      sprintf(buf, "%c%sE%s", ctx.sign, p, ctx.exp) ;
    drawText(screen,buf, 25, 10, 0, 0, 0, 0) ;
    // sprintf(buf, "%lf", ctx.acc) ;
    // drawText(screen,buf,10,100,0,0,0,1);
  }
  // drawText(screen,Tekst,20,10,0,0,0);
  if(SDL_Flip(screen)<0) fprintf(stderr,"SDL_Flip failed");
}

void handleMOUSEevent(int button, SDL_Surface* screen)
{
  calc(button) ;
  display_all(screen) ;
}

void getVersion()
{
  char buf[10] ;
  FILE *fin = fopen("/usr/gp2x/version", "r") ;
  if (fin!=NULL)
  {
    int n = fread(buf, 1, sizeof(buf)-1, fin) ;
    fclose(fin) ;
    if (buf[0]>'4') v400 = 0 ; else 
    if (buf[2]>'0') v400 = 0 ; else v400 = 1 ;
  }
}

int main (int argc, char **argv) 
{
    int fd = 0;
    SDL_Event event;
    TS_EVENT ts_event;
    SDL_Surface *screen;
    unsigned long int antirebond ;

    int channel = -1;
    Mix_Chunk *sound = NULL;
    int audio_rate = 22050;
    Uint16 audio_format = AUDIO_S8;
    int audio_channels = 1;
    int audio_buffers = 32 ;

   // sout = fopen("/mnt/sd/out.txt", "w") ;
   // sout = fopen("/dev/null", "w") ;

    // init sdl
    if(SDL_Init(SDL_INIT_JOYSTICK | SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_TIMER)<0)
    {
      fprintf(stderr,"Couldn't initialize SDL");
    }
    // setup screen
    screen = SDL_SetVideoMode( 320,240,16, SDL_SWSURFACE );
    if(!screen)
      fprintf(stderr,"Couldn't set video mode");
    SDL_JoystickOpen(0);
    TTF_Init();
    calc_init() ;
    ctx.lastx = 0L ;
    font = TTF_OpenFont("fcalc/arial.ttf",30);
    fontSmall = TTF_OpenFont("fcalc/arial.ttf",15);
#if GP2X
     SDL_ShowCursor(SDL_DISABLE) ;
#endif 
    if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers) != 0) 
    {
	fprintf(stderr, "Unable to initialize audio: %s\n", Mix_GetError());
    }  
    sound = Mix_LoadWAV("fcalc/fcalc.wav");
    if(sound == NULL) {
	fprintf(stderr, "Unable to load WAV file: %s\n", Mix_GetError());
    }

    getVersion() ;
    display_all(screen) ;
    
    antirebond = time_msec() ;
    while(!quit)
    {
        while(SDL_PollEvent(&event))
        {
          handleSDLEvent(&event, screen, sound);
        }
#if 1 
	int got_mouse = 0 ;
        static int x=0, y=0;
  	if (v400==0)
	{
	  got_mouse = SDL_GetMouseState(&x, &y) ;
	} else {
          static char autocalib=1;
          static int calibX=0, calibY=0;
	  if (fd==0) 
	    fd = open( "/dev/touchscreen/wm97xx", O_RDONLY | O_NOCTTY );
	  if (fd)
	  {
	    memset(&ts_event, 0, sizeof(TS_EVENT));
            int nbr = read(fd, &ts_event, sizeof(TS_EVENT));
	    if (nbr==0) continue ;
            //use the first frame to calibrate the touchscreen
            if (autocalib&&ts_event.pressure==0)
            {
                //these are experimental values from some calibrations and tries
                //not pixel perfect, so i divide by 4 to give less importance to it
                //and possibly have a minor range of error on different gp2xs
                calibX = ((ts_event.x-200)*320/3750)/4;
                calibY = (((ts_event.y-200)*240/3750))/4;
                autocalib=0;
            }

            //store screen coords

            //convert touchscreen coords to screen coords
            x = ((ts_event.x-200)*320/3750)-calibX;
            y = (240 - ((ts_event.y-200)*240/3750))-calibY;

	    if (v400==0)
	    {
		int ox = x ;
		int oy = y ;
		x = 320 * (240-oy) / 240;
		y = 240 * (320-ox) / 320;
	    }
	    got_mouse = (ts_event.pressure>0) ;
	  }
	}
        if (got_mouse)
	{
	   int button ;
	   if (antirebond > time_msec()) 
		continue ; 
	   antirebond = time_msec() + 200 ;
 
  	   button = translateXY(x, y) ;
  	   if (button!=0) 
	   {
	     channel = Mix_PlayChannel(-1, sound, 0);
	     if(channel == -1) {
	       fprintf(stderr, "Unable to play WAV file: %s\n", Mix_GetError());
	     } 
	     handleMOUSEevent(button, screen) ;
	   }
	}
            // background
#endif
    }
    close(fd) ;
    

    SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0x80,0x80,0xFF));
    SDL_Flip(screen);
    SDL_FreeSurface(screen);
    TTF_CloseFont(font);
    TTF_CloseFont(fontSmall);
    if (channel != -1)
	while(Mix_Playing(channel) != 0);
    Mix_FreeChunk(sound);
    Mix_CloseAudio();
    SDL_Quit();
    // fclose(sout) ;
#if GP2X
    libSDL_close() ;
    libMix_close() ;
    libTTF_close() ;
#endif
    // run menu back
    chdir("/usr/gp2x");
    execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
    exit(0);
}
